/****************************************/
/*		z[ZTo͕\H		*/
/****************************************/
//		ATTINY861gp				
//		8MHzNbN		
//		Fuse  : -fh11011100 -fl11100010
//					DC          E2
//		tool : AVR Studio Version 4, 19, 0, 730

//		ϰ0	1mS荞		
//		LCD		8~2s ACM0802C
//		A/D ch 9:z[ZT
//		A/D ch 8:drd

//		PA0	  out LCD RS
//		PA1	  out LCD R/W
//		PA2	  out LCD E
//		PA3	  in  AREF
//		PA4	  i/o LCD D4
//		PA5	  i/o LCD D5
//		PA6	  i/o LCD D6
//		PA7	  i/o LCD D7
//		PB0	  in  [_XCb` (LŃI)
//		PB1	  in  ZT[IXCb`
//		PB2	  in  j^[XCb`
//		PB3	  out (NC)
//		PB4	  out (NC)
//		PB5	  in  ADC8 drd
//		PB6	  in  ADC9 z[ZT

//		2015-03-10	Jn
//		        13	P[X
//				24	o[W

/*****	CN[h		*****/
#include <inttypes.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h> 

/*****	ݻނ̕ϐ`	*****/
typedef uint8_t			byte;
typedef uint16_t		word;
typedef uint32_t		lword;

/*****	zްԂϸ		*****/
#define		DIMSIZ(a)	(sizeof(a)/sizeof(*a))

/*****	I/O|[g`			*****/
#define	PIN_SW		(~PINB & 0x07)		// XCb`̓|[g

/*****	XCb`̔ԍ		*****/
#define	SW_ZERO			0		// [_킹XCb`
#define	SW_SEL			1		// ZTIXCb`
#define	SW_ADDISP		2		// A/Dl\

/*****	}N			*****/
#define	nop()		asm volatile("nop;")	// NOPR[h

/****************************/
/*		O[of[^	*/
/****************************/

/*****	1mS ^C}[f[^		*****/
volatile byte	tm_1ms;			// 1mS^C}[@_EJEg
//		LCD \p
volatile byte	tmlcd_busy;		// LCD busy  ϰ
volatile byte	tmlcd_wait;		// LCD ԑ҂ ϰ

/*****	tO		*****/
volatile byte 	f_tm1ms;		// 1mS^C}[荞݃tO
								// 荞݂ނ̂ŉ̃tOƂ͕ʂ
/*****  XCb`f[^,tO   *****/
//	    荞݂Őݒ肳̂͏O
typedef struct{
	uint8_t    sdisp:1;          // ZT[f[^\tO
	uint8_t    batlo:1;          // drdቺtO
}flag;    
flag f;                  // tO̎

/*****	A/D f[^		*****/
#define AD_CH		2			// A/D`l
#define AD_AVR		128			// A/Dω
#define	AD_SENS		0			// ch9 ZT[d
#define	AD_BAT		1			// ch8 drd

volatile byte 	ad_ch;			// A/Dϊ`l
								// 0`1
volatile word 	ad_cnt;			// A/Dω
								// 0`255
volatile lword	ad_add[AD_CH];	// A/DωZl
volatile word   ad_data[AD_CH];	// A/Dσf[^
volatile byte 	ad_ok;			// A/DϊtO
								// ϊƂ+1
volatile byte 	ad_blcnt;		// _ŗpJE^
volatile byte 	f_blink;		// I[o[W_ŃtO
								// ad_okɓĕω
/****************************/
/*		ddoqnl		*/
/****************************/

/***** ZT[XybN		*****/
typedef struct{
	char	name[10];		// ZT[
	word	gauss;			// 1VłmTl~10 (GƂ̂܂)
	word	zero;			// [_ A/Dl 0`1023
	word	sat;			// Oax`FbNpA/Dl
}sensor_spec;

/*****	EEPROMɕۑZT[̃XybN	*****/
//		́A[_ʒuAx(1ṼKEXl xx.xmT)
//		+/-tXP[`FbNpA/Dl
sensor_spec EEMEM eep_sensor[]={
	{ "A1324   ",  200,  625,  500	},		// 0
	{ "SS495B  ",  320,  616,  500	},		// 1
	{ "DRV5053V",  111,  248,  200	},		// 2
	{ "DRV5053O",  909,  254,  200	},		// 3
};	// 01234567    gauss zero  sat

/*****	EEPROM f[^		*****/
word eep_lowbat		EEMEM = 248;	// Low Batdrd
									// AD_BATƔr
word eep_lowbath	EEMEM = 254;	// Low Bat񕜓d
									// qXeVX
byte eep_selsens	EEMEM = 0;		// IZT[ԍ
									// 0`34
word eep_vref		EEMEM = 4097;	// Vrefd  mVl
									// A/Dmaxl+1̓d
word eep_adfuls		EEMEM = 1024;	// A/Df[^tXP[
									// 0`1023
/*****	RAM GA		*****/
//	EEPROM̃f[^Rs[
word low_bat;						// LOW BAT\pA/Dr
word low_bath;						// LOW BATqXeVX
byte sel_sens;						// IZT[ԍ
word v_ref;							// Vrefd  mVl
word ad_fuls;						// A/Df[^tXP[
sensor_spec sel_spec;				// ZT[̃XybN
									// IĂZT[̂
/*****	ǂݏof[^̃AhX	*****/
const struct{
	byte	n;			// f[^oCg
	void	*eep;		// EEPROMf[^
	void	*ram;		// RAM̃AhX
}PROGMEM eeproms[]={
	{ sizeof(low_bat),		&eep_lowbat,		&low_bat  	 },		// 0
	{ sizeof(low_bath),		&eep_lowbath,		&low_bath  	 },		// 1
	{ sizeof(sel_sens),		&eep_selsens,		&sel_sens	 },		// 2
	{ sizeof(v_ref),		&eep_vref,			&v_ref		 },		// 3
	{ sizeof(ad_fuls),		&eep_adfuls,		&ad_fuls	 },		// 4
};

/*****	EEPROMRAM ǂݏo		*****/
//		RAMɓ]
void eeptoram(void)
{
int i;
void *p;
	for(i = 0; i < DIMSIZ(eeproms); i++){
	  p = (void *)pgm_read_word(&eeproms[i].eep);
	  eeprom_busy_wait();				// EEPROMANZX\҂
	  switch(pgm_read_byte(&eeproms[i].n)){				// oCgŋ敪
		case 1:		// BYTE
		  *(byte *)pgm_read_word(&eeproms[i].ram) = eeprom_read_byte((byte *)p);
		  break;		  
		case 2:		//WORD
		  *(word *)pgm_read_word(&eeproms[i].ram) = eeprom_read_word((word *)p);
		  break;		  
	  }
	}
}

/*****	IZT[̃XybNEEPROM烊[h	*****/
void readspec(void)
{
    eeprom_busy_wait();
	eeprom_read_block(&sel_spec, &eep_sensor[sel_sens], sizeof(sel_spec));
}

/*****	IZT[̃[_A/DlEEPROMɏ	*****/
void writezero(void)
{
    eeprom_busy_wait();
	eeprom_update_word(&eep_sensor[sel_sens].zero, sel_spec.zero);
}

/*****	IZT[ԍEEPROMɕۑ	*****/
void saveselsens(void)
{
    eeprom_busy_wait();
	eeprom_update_byte(&eep_selsens, sel_sens);
}

/****************************/
/*						*/
/****************************/

/*****				*****/
void ioinit(void)
{
	PORTA = 0b00000000;		//
	DDRA  = 0b00000111;
	//	 	  |||||||+----	PA0 out LCD RS
	//		  ||||||+-----	PA1	out LCD R/W
	//		  |||||+------	PA2 out LCD E
	//		  ||||+-------	PA3 in  AREF
	//		  |||+--------	PA4 i/o LCD D4
	//		  ||+---------	PA5 i/o LCD D5
	//		  |+----------	PA6 i/o LCD D6
	//		  +-----------	PA7 i/o LCD D7
	PORTB = 0b00000111;		// PB4 pull up
	DDRB  = 0b00011000;
	//	 	   ||||||+----	PB0 in  SW1
	//		   |||||+-----	PB1	in  SW2
	//		   ||||+------	PB2 in  SW3 
	//		   |||+-------	PB3 out (NC)
	//		   ||+--------	PB4 out (NC)  
	//		   |+---------	PB5 in  ADC8
	//		   +----------	PB6 in  ADC9

//	A/D
	DIDR0  = 0b00001000;
	//		       +------	AREF
	DIDR1  = 0b01100000;
	//		    ++--------	A/D	ch9,8
	ADCSRA = 0b10001110;
	//		   |   |+++---	CLK 1/64 125kHz
	//		   |   +------	ADIE
	//		   +----------	ADEN
	ADCSRB = 0b00000000;
	//		   || ||+++---	free run
	//		   || |+------	MUX5
	//		   || +-------	REFS2
	//		   |+---------	GSEL
	//		   +----------	BIN
	ADMUX  = 0b01001001;
	//		   |||+++++---	MUX ch9
	//		   ||+--------	ADLAR
	//		   ++---------	REFS :AREF
	
//	^C}[0
	TCCR0A = 0b00000001;
	//                +---	CTC0 OCR0Atop
	TCCR0B = 0b00000011;
	//			   |+++---	CLK/64
	//			   +------	PSR0
	OCR0A  = 125-1;			// 1000Hz (8MHz / 64 / 125)
	TIMSK  = 0b00010000;
	//			  +-------	OCIE0A ߯ĺ߱荞
}

/********************************/
/*		^C}[0荞		*/
/********************************/

/*****	^C}[0荞ݏ		*****/
//		A/DϊJn
SIGNAL(TIMER0_COMPA_vect)
{
static byte cnt100 = 0;				// 0.1secJEg
	PORTB |= (1 << PB3);			// ԊmF(!!!)
	if(tm_1ms)		tm_1ms--;		// 1ms^C}[_EJEg
	if(tmlcd_busy)	tmlcd_busy--;	// LCD busy  ϰ
	if(tmlcd_wait)	tmlcd_wait--;	// LCD ԑ҂ ϰ
	f_tm1ms = 1;					// 1ms tOI
//	100ms^C}[
	cnt100++;
	if(cnt100 >= 100){				// 100ms
		cnt100 = 0;
	}
//	A/DϊJn
	ADCSRA |= (1 << ADSC);			// A/DϊJn
	PORTB &= ~(1 << PB3);			// (!!!)
}

/********************************/
/*		A/Dϊ荞			*/
/********************************/

/*****	A/Dϊ MUX e[u	*****/
const byte PROGMEM ad_muxtbl[] = {
		0b01001001,		// 0 ch 9 ZT[
		0b01001000,		// 1 ch 8 drd
//		  |||+++++---	MUX ch0
//		  ||+--------	ADLAR
//		  ++---------	REFS :AREF
};

/*****	A/Dϊ荞ݏ		*****/
//		ϊJn1ms^C}[荞ݓ
//		1ms~2ch~128񕽋  256mSŊm
SIGNAL(ADC_vect)
{
word d;
	PORTB |= (1 << PB3);			// ԊmF(!!!)
	d  = (word)ADCL;				// A/Dϊ
	d += ((ADCH & 0x03) << 8);
	ad_add[ad_ch] += (lword)d;		// ϒlZ
	ad_ch++;						// ch
	if(ad_ch >= AD_CH){				// ch 9,8?
		ad_ch = 0;					// ch 9ɖ߂
		ad_cnt++;					// Z+1
		if(ad_cnt >= AD_AVR){		// Z񐔃`FbN
			ad_cnt = 0;				// ωZŏ
			ad_data[0] = (word)(ad_add[0] / AD_AVR);	// ch 9
			ad_data[1] = (word)(ad_add[1] / AD_AVR);	// ch 8
			ad_add[0] = 0;					// Zۂ	
			ad_add[1] = 0;
			if(ad_ok < 255)		ad_ok++;	// A/DtOon
			ad_blcnt++;
			if(ad_blcnt >= 2){		// _ŗp 512mS
				ad_blcnt = 0;
				f_blink ^= 1;		// _ŃtO]
			}
		}
	}
	ADMUX = pgm_read_byte(&ad_muxtbl[ad_ch]);	// A/D muxI
	PORTB &= ~(1 << PB3);			// (!!!)
}

/************************************/
/*		kbc\					*/
/************************************/
//		8~2sACM0802Cgp

/*****	LCD ߰		*****/
//		ް4bitPA4`PA7ɂȂ
//		H,L̏ɓ]
//		ҋ@ԂłPA4`PA7͂
//		RS:PA0, R/W:PA1, E:PA2, Data:PA4`7	*/
#define		LCD_RS			(1 << PA0)				/* PA0 RS		*/
#define		LCD_RW			(1 << PA1)				/* PA1 R/W		*/
#define		LCD_E			(1 << PA2)				/* PA2 E		*/
#define		LCD_DOUT		(PORTA)					/* PA  DATA out	*/
#define		LCD_DINP		(PINA)					/* PA  DATA in 	*/
#define		LCD_DIR			(DDRA)					/* PA  DIR  	*/
#define		lcdinp()		(LCD_DIR=0x07)			/* PA  ͂ 	*/
#define		lcdout()		(LCD_DIR=0xF7)			/* PA  o͂  	*/
#define		lcdwait()		cli()					/* Ԃ  	*/
// #define	lcdwait()		nop()					/* Ԃ  	*/

/*****	1msvϰ	*****/
/* 		ϰ荞݂tmlcd_busytmlcd_wait޳ݶ 		*/
// volatile uchar	tmlcd_busy;			/* LCD busy  ϰ		*/
// volatile uchar	tmlcd_wait;			/* LCD ԑ҂ ϰ		*/

#define	LCDTM_BUSY		20			/* busy  ϰ, 20ms	*/

/*****	وʒuް		*****/
byte	cur_pos;					/* وʒu				*/

/*****	LCD ޏ(busyȂ)	*****/
/*		d̉4bitӰĂ			*/
void lcddwrc(byte d)
{
	cli();							/* 荞݋֎~ */
	d &= 0x0F;
	LCD_DOUT = (d << 4);			/* RS=0,R/W=0	 */
	lcdout();						/* oӰނ */
	lcdwait();
	LCD_DOUT |=  LCD_E;				/* Eĸ	*/
	lcdwait();
	LCD_DOUT &= ~LCD_E;
	lcdwait();
	LCD_DOUT = (d << 4) | LCD_RS | LCD_RW;	/* RS=1,R/W=1	 */
	lcdinp();						/* Ӱނɖ߂Ă */
	sei();							/* 荞ݲȰ */
}

/*****	LCD ް(busyȂ)	*****/
void lcddwrd(byte d)
{
	cli();							/* 荞݋֎~ */
	d &= 0x0F;
	LCD_DOUT = (d << 4) | LCD_RS;	/* RS=1,R/W=0	 */
	lcdout();						/* oӰނ */
	lcdwait();
	LCD_DOUT |=  LCD_E;				/* Eĸ	*/
	lcdwait();
	LCD_DOUT &= ~LCD_E;
	lcdwait();
	LCD_DOUT = (d << 4) | LCD_RS | LCD_RW;	/* RS=1,R/W=1	 */
	lcdinp();						/* Ӱނɖ߂Ă */
	sei();							/* 荞ݲȰ */
}

/*****	LCD 4bit*2 ذ		*****/
byte lcdrd4(void)
{
byte dh,dl;
	cli();							/* 荞݋֎~ */
	LCD_DOUT |= LCD_E;				/* Eĸ	*/
	lcdwait();
	dh = LCD_DINP;					/* Hް	*/
	LCD_DOUT &= ~LCD_E;
	lcdwait();
	lcdwait();
	LCD_DOUT |= LCD_E;				/* Eĸ	*/
	lcdwait();
	dl = LCD_DINP;					/* Lް	*/
	LCD_DOUT &= ~LCD_E;
	sei();							/* 荞ݲȰ */
	return  (dh & 0xF0) | ((dl >> 4) & 0x0F);
}

/*****	LCD busy 	*****/
/*		busy邢ѱĂ܂ő҂	*/
void lcdbusy(void)
{
byte d;
	LCD_DOUT = LCD_RW;				/* RS=0,R/W=1	 */
	lcdinp();						/* Ӱ */
	tmlcd_busy = LCDTM_BUSY;		/* busy  ϰ */
	do{
		d = lcdrd4();					/* 4bit*2 ްذ	*/
	}while(((d & 0x80) != 0) && 		/* busy ޯĂ1Ȃloop */
		   (tmlcd_busy != 0));			/* ѱ */
	LCD_DOUT = LCD_RS | LCD_RW;			/* RS=1,R/W=1	 */
}

/*****	LCD ްǂݏo	*****/
/*		busy4ޯĂH,L̏	*/
byte lcdrd(void)
{
byte d;
	lcdbusy();						/* busy҂ */
	LCD_DOUT = LCD_RS | LCD_RW;		/* RS=1,R/W=1	 */
	lcdinp();						/* Ӱ */
	d = lcdrd4();					/* 4bit*2 ްذ	*/
	return d;
}

/*****	LCD ް	*****/
/*		busy4ޯĂH,L̏	*/
void lcdwr(byte d)
{
	lcdbusy();							/* busy҂ */
	lcddwrd(d >> 4);					/* ް H */
	lcddwrd(d);							/* L޲	 */
}

/*****	LCD ޏ	*****/
/*		busy4ޯĂH,L̏	*/
void lcdcmd(byte d)
{
	lcdbusy();							/* busy҂ */
	lcddwrc(d >> 4);					/* ޏ H */
	lcddwrc(d);							/* L޲ */
}

/*****	LCD Ƽ			*****/
/*		4ޯ Ӱ				*/
/*		Ƽق̍ŏbusyłȂ ϰ҂	*/
void lcdinit(void)
{
int i;
static const byte PROGMEM t[]={	/* ԑ҂ް (1ms) */
	50,						/* 50ms	 	*/
	10,						/* 10ms		*/
	10,						/* 10ms		*/
};
static const byte PROGMEM w[]={		/* ް */
	0x28,					/*	0 00101000	4bitӰ2sƼ ް	*/
	0x08,					/*	1 00001000	S\				*/
	0x01,					/*	2 00000001	S\ر				*/
	0x06,					/*	3 00000110	ݸ Ӱ			*/
	0x0C,					/*	4 00001100	\on(ٕ\͂Ȃ)	*/
	0x10,					/*	5 00010000	ټĂȂ				*/
	0x80,					/*	6 10000000	DD-RAMڽ				*/
};
	for(i = 0; i < 3; i++){				/* 3 */
		tmlcd_wait = pgm_read_byte(&t[i]); 	/* ԑ҂ް (x1ms) */
		while(tmlcd_wait);
		lcddwrc(0x03);					/* (busy Ȃ) */
	}
	lcdbusy();							/* busy҂ */
	lcddwrc(0x02);						/* 4ޯӰ */
	for(i = 0; i < DIMSIZ(w); i++){		/* 6 */
		lcdcmd(pgm_read_byte(&w[i]));	/* ޏ */
	}
}

/*****  LCD  home   *****/
void lcdhome(void)
{
    lcdcmd(0x02);                   /*  00000010 */
    cur_pos=0;
}

/*****  LCD  ړ   *****/
/*      p:0`15             */
void lcdmove(byte n)
{
byte x,y;
static const byte yy[]={        /* ʒu */
    0x00,                       /* 0    */
    0x40,                       /* 8    */
};
	n = n % 16;						/* 0`15͈  */
	cur_pos = n;       	            /* Vʒu */
    y = n / 8;                    	/* Yʒu	*/
    x = n % 8;						/* Xʒu	*/
    lcdcmd(yy[y] + x + 0x80);       /* DD RAM ڽ  */
}

/*****  LCD ʸر     *****/
/*      ق̂home߼޼݂   */
void lcdclr(void)
{
    lcdcmd(0x01);                   /* ʸر,home */
    cur_pos = 0;                    /* وʒu=0 */
}

/*****  LCD s܂Ÿر     *****/
/*      ݍs̍s܂Ÿر     */
/*      -وʒu͎̍s        */
void lcdclreol(void)
{
byte i,x1,x2;
    x1 = cur_pos;                       /* وʒu */
    x2 = ((cur_pos / 8) * 8)+7;         /* s̉E[ (1s8) */
    for(i = x1; i <= x2; i++){
        lcdwr(' ');                     /* space */
    }
    lcdmove(i);                         /* sɶوړ */
}

/*****  LCD 1sر          *****/
/*      ق̂s      */
/*      -وʒu͍s̍[      */
void lcdclrline(void)
{
byte i,x1,x2;
    x1 = (cur_pos / 8) * 8;             /* s̍[ */
    x2 = x1 + 7;                        /* s̉E[ */
    for(i = x1; i <= x2; i++){
        lcdwr(' ');                     /* space */
    }
    lcdmove(x1);                        /* وʒu͍[ */
}

/*****  LCD 1   *****/
/*      sςζوړ    */
/*      Ō܂ŗ擪    */
void lcdputch(byte d)
{
    lcdwr(d);                           /* 1 */
    cur_pos++;                          /* وʒu E */
    if(cur_pos >= 16){                  /* ʔ͈͊O */
        cur_pos = 0;
    }
    lcdmove(cur_pos);                   /* Vوʒu */
}

/*****  LCD 񏑂  *****/
/*      null Ȱ             */
void lcdputs(char *s)
{
    while(*s){                          /* null܂ */
        lcdputch(*s);                   /* 1\ */
        s++;                            /*  */
    }
}

/*****  ʒuwt\      *****/
void lcdpputs(byte p, char *s)
{
    lcdmove(p);                         /* وړ */
    lcdputs(s);                         /* \ */
}

/*****  LCDwtpL\   *****/
/*      printfƓ@\                        */
void lcdprintf(char *s, ...)
{
va_list vp;
char bff[20];                              /* 20ޯ̧ */
    va_start(vp,s);
    vsprintf(bff,s,vp);
    lcdputs(bff);
    va_end(vp);
}

/*****  LCDʒuwtw蕶\ *****/
/*      p:ʒu                          */
void lcdpprintf(byte p,char *s, ...)
{
va_list vp;
char bff[20];                              /* 20ޯ̧ */
    va_start(vp,s);
    vsprintf(bff,s,vp);
    lcdpputs(p, bff);
    va_end(vp);
}

/****************************************/
/*		XCb``FbN				*/
/****************************************/

/*****	XCb`̓f[^	*****/
byte sw_inp;			// XCb`͏
byte sw_on;				// XCb`onf[^
						// 1ŃI bit0
byte sw_chk[5];			// ω`FbNf[^
						// 10msTCN
/*****	XCb`̓`FbN		*****/
//		1ms^C}[ŋN
//		10msœ͊m
void swchk(void)
{
byte i,m,d0,d1;
static byte tm = 0;
	if(tm == 0){						// 2msTCNŎs
		tm = 1;
		for(i = 0; i < (DIMSIZ(sw_chk)-1); i++){
			sw_chk[i+1] = sw_chk[i];		// [0]ŐV
		}
		sw_chk[0] = PIN_SW;					// HŃI 0000_0111
		d0 = 0x00;							// L
		d1 = 0x07;							// H
		for(i = 0; i < DIMSIZ(sw_chk); i++){
			d0 |= sw_chk[i];
			d1 &= sw_chk[i];
		}
		m = (~d0) | d1;					// 1̂Ƃ낪f[^
		d0 = sw_inp;								// ȑO̓
		sw_inp = (d0 & (~m)) | (sw_chk[0] & m);		// VԊm
		sw_on |= (~d0) & sw_inp;					// GbWo
	}
	else{
		tm--;							// ^C}[ -1
	}
}

/*****	XCb`͏ԃ`FbN	*****/
//		n : SWԍ
//		on1, offȂ0
byte swinp(byte n)
{
	if(sw_inp & (1 << n))		return 1;
	else						return 0;
}

/*****	XCb`I`FbN	*****/
//		n : SWԍ
//		on1, offȂ0
byte swon(byte n)
{
byte m,r;
	m = 1 << n;					// SW ޯĈʒu
	if(sw_on & m)		r = 1;
	else				r = 0;
	sw_on &= ~m;				// }XN
	return r;
}

/************************************/
/*		s⏕[`			*/
/************************************/

/*****	drd`FbN	*****/
//		̃ZT[̐擪_
void batlochk(void)
{
word d;
	cli();						// 荞݋֎~
	d = ad_data[AD_BAT];		// drd
	sei();						// 荞ݍĊJ
	if(f.batlo){				// LOW BAT
		if(d > low_bath)	f.batlo = 0;	// qXeVX
	}
	else{
		if(d < low_bat)		f.batlo = 1;	// LOW BATo
	}
	if((f.batlo) && (f_blink == 0)){		// LOW BATœ_
		lcdmove(0);							// وړ
	   	lcdputch(' ');						// ̐擪
	}
}

/*****	[ItZbg͏	*****/
void zeroset(void)
{
word d;
	cli();						// 荞݋֎~
	d = ad_data[AD_SENS];		// ZT[A/Dl
	sei();						// 荞ݍĊJ
	sel_spec.zero = d;			// [_A/Dl
	writezero();				// EEPROMɕۑ
	f.sdisp = 1;
}

/*****	ZT[ԍ+1	*****/
void nextsens(void)
{
	sel_sens++;
	if(sel_sens >= DIMSIZ(eep_sensor))	sel_sens = 0;
	readspec();			// IZT[̃XybN[h
	saveselsens();		// IZT[ԍEEPROM
	f.sdisp = 1;
}

/*****	͌vZ,\		*****/
//		d(mV) = ((A/D - zero) * Vref) / adfuls
//		 = gauss * d / 1000
//		OaxȂumTv_
void dispmtesla(void)
{
int a, d, d1, d2;
double f1;
char s[10];
	cli();						// 荞݋֎~
	a = ad_data[AD_SENS];		// ZT[A/Dl
	sei();						// 荞ݍĊJ
	d = a - sel_spec.zero;		// [_␳
#if 0
long v, t;
	v = ((long)d * (long)v_ref) / (long)ad_fuls;	// mVPʂA/Dl
	t = ((long)sel_spec.gauss * v ) / 1000L; 		// xx.xmT(xxxG)ŌvZ
	d = (int)t;
	lcdmove(8);					// وړ
	lcdprintf("%4d.%d", d / 10 , abs(d) % 10);
#endif
	lcdmove(8);					// وړ
	f1 = ((double)d * (double)v_ref * (double)sel_spec.gauss) /
				 (10000.0 * (double)ad_fuls);
	dtostrf(f1 , 6, 1, s);		// ɕϊ
	lcdputs(s);
//	Oax`FbN
	lcdmove(8+6);				// وړ
	d1 = sel_spec.zero + sel_spec.sat;		// +Oa
	d2 = sel_spec.zero - sel_spec.sat;		// -Oa
	if(d1 >= ad_fuls)	d1 = ad_fuls - 1;	// 0`1023Ő
	if(d2 < 0)			d2 = 0;
	if(((a >= d1) || (a <= d2)) &&			// +/-ǂ炩Oa
	   (f_blink == 0))		lcdputs("  ");	// _Ń^C~O
	else					lcdputs("mT");
}

/********************************/
/*		Xebvs		*/
/********************************/

/*****	s敪		*****/
byte j_exc;					// sXebv

#define	J_SDISP1		3		// ZT[f[^\
#define	J_ADCHK1		4		// A/D`FbN

/*****	^Cg1		*****/
void jttl1(void)
{
	lcdpputs(0, "Hall      Sensor");	// ^Cg
//			     0123456701234567
	ad_ok = 0;
	j_exc++;							// next step
}

/*****	^CgQ		*****/
//	IZT[\
//	[Ɗxݒl
void jttl2(void)
{
	if(ad_ok >= 4){					// 256mS~4 ҂
		lcdclr();					// ʃNA
		lcdpprintf(0, "%s", sel_spec.name);
		lcdpprintf(8, "%4d%4d", sel_spec.zero, sel_spec.gauss);
		ad_ok = 0;
		j_exc++;					// next step
	}
}

/*****	^CgR		*****/
void jttl3(void)
{
	if(ad_ok >= 4){					// 256mS~4 ҂
		lcdclr();					// ʃNA
		j_exc = J_SDISP1;			// l\
	}
}

/*****	ZT[l\P	*****/
void jsdisp1(void)
{
	if(ad_ok || f.sdisp){		// A/Dϊ or \w
		ad_ok = 0;
		f.sdisp = 0;
		lcdpputs(0, sel_spec.name);
		dispmtesla();				// ͌vZ,\
		batlochk();					// Bat Low`FbN
	}
//	XCb`̓`FbN
	if(swon(SW_ZERO)){
		zeroset();			// [_Zbg
	}
	if(swon(SW_SEL)){		// ZT[I
		nextsens();					// ZT[ԍ+1
	}
	if(swon(SW_ADDISP)){	// A/Dl\
		lcdclr();					// ʃNA
		f.sdisp = 1;
		j_exc = J_ADCHK1;			// A/Dl`FbN
	}
}

/*****	A/D`FbNP	*****/
void jadchk1(void)
{
word d1, d2;
	cli();						// 荞݋֎~
	d1 = ad_data[AD_SENS];		// ZT[ A/Dl
	d2 = ad_data[AD_BAT];		// drdA/Dl
	sei();						// 荞ݍĊJ
	if(ad_ok || f.sdisp){		// A/Dϊ or \w
		ad_ok = 0;
		f.sdisp = 0;
		lcdpprintf(0, "%4d%4d", d1, d2);	// A/Dl
		lcdpprintf(8, "%4d%4d", sel_spec.zero, sel_spec.gauss); // ZT[XybN
	}
	if(swon(SW_ZERO)){
		zeroset();			// [_Zbg
	}
	if(swon(SW_SEL)){		// ZT[I
		nextsens();					// ZT[ԍ+1
	}
	if(swon(SW_ADDISP)){	// A/Dl\
		lcdclr();					// ʃNA
		f.sdisp = 1;
		j_exc = J_SDISP1;			// ֖߂
	}
}

/************************************/
/*		Xebvs				*/
/************************************/

/*****	Xebvs		*****/
typedef void (*JOB)(void);

//		s֐e[u
const JOB jobtbl[] PROGMEM = {
	jttl1,				//   0	^Cg
	jttl2,				//   1
	jttl3,				//   2
	jsdisp1,			//   3	ZT[f[^\
	jadchk1,			//   4	A/Df[^`FbN
};

//		s̊֐
void jobexc(void)
{
JOB jj;
	jj = (JOB)pgm_read_word(&jobtbl[j_exc]);	// sð
	jj();										// s
}

/****************************/
/*		l`hms		*/
/****************************/

/*****	l`hm			*****/
int main(void)
{
	ioinit();					// I/OƼ
	eeptoram();					// EEPROMRAM ǂݏo
	readspec();					// IZT[̃XybN[h
	sei();						// 荞ݲȰ
	lcdinit();					// tƼ

//	sloop
	while(1){
		if(f_tm1ms){			// 1msTCN
			PORTB |= (1 << PB4);			// ԊmF(!!!)
			f_tm1ms = 0;
			swchk();			// SW̓`FbN
			PORTB &= ~(1 << PB4);			// ԊmF(!!!)
		}
		jobexc();				// vXebvs
	}
}

/*====	end of "HALL_SENS1.c"	====*/
